FUNCTION Bricket
PARAMETERS Link, Variant, RepTitle, RepParam, RepEnd, Detail 
* Link -  BROWSE (C)
* Variant - = 1  (N)
*RepTitle -   (C)
*RepParam -   (C)
*RepEnd -  (C)

*  ,  
* Brick_fn -  (C)
* Brick_fs -  (N)
* Brick_fb - / (.T./.F.) (L)
* Brick_fi - / (.T./.F.) (L)
* Brick_orient -  (0/1) (N)

PUSH KEY CLEAR
PRIVATE nBrowse, RepName
IF type('m.Variant') = 'L' 
  Variant = iif(m.Variant, 2, 1)
ENDIF
IF type('m.RepParam') != 'C' 
  RepParam = ''
ENDIF
IF type('m.RepEnd') != 'C' 
  RepEnd = ''
ENDIF
DO CASE
   CASE m.Variant = 1
     nBrowse = Link
   CASE m.Variant = 2
     nBrowse = 'Link'
   CASE m.Variant = 3
     RepName = Link
   OTHERWISE
     POP KEY
     RETURN
ENDCASE     
IF type('m.Detail') != 'C'
  Detail = ''
ENDIF
PRIVATE StatBar, Century
Century = set('Century')
SET CENTURY OFF      &&  BROWSE (GRID) ??    
StatBar = set('Status bar')
SET STATUS BAR OFF

*
PRIVATE i, j, ti, np, fn, fs, fb, fi, he, rc, wa, wal, pa, pz
PRIVATE ActCol, ActRow, LeftCol
PRIVATE kt, ktx, ktt, nColumn
PRIVATE px, py, tip, nStr, nSto, nStrMax, nSum, FirstTime
PRIVATE pp, paper, orient, FirstPage  
PRIVATE White, Black, Yellow, Gray, Blue, Red
PRIVATE rStandart, rQuick
PRIVATE fNot, fnof, fOld
PRIVATE scrWidth, scrHeight, winWidth, winHeight

scrWidth = sysmetric(1)
scrHeight = sysmetric(2)
winHeight = m.scrHeight - 140  && 460
winWidth = m.scrWidth - 20    && 780

*PRIVATE pText, pF1, pF2, pF3
nColumn = 1
wa = select()
wal = alias()
fOld = filter()
IF empty(m.fOld)
  fnot = '.T.'
ELSE
  fnot = '('+m.fOld+')'
ENDIF  
fnof = ''
*pText = ''
*pF1 = .T.
*pF2 = .F.
*pF3 = .T.
IF .f.
  = b_menu()
ENDIF
*
*

White  = rgb(255,255,255)
Black  = rgb(  0,  0,  0)
Yellow = rgb(255,255,190)
Gray   = rgb(190,190,190)
Blue   = rgb(190,255,255)
Red    = rgb(255,0,0)
FirstTime = .T.
FirstPage = 1
pp = 0
paper = '??'
orient = 0
= fPaper()
rc = recno()
IF m.Variant = 3
  ti = iif(type('m.RepTitle')='C', m.RepTitle, '')
  pa = iif(type('m.RepParam')='C', m.RepParam, '')
  pz = iif(type('m.RepEnd')='C', m.RepEnd, '')
  np = alen(aColumns, 1)      &&  
  fn = 'Times New Roman'      &&  
  fs = 10                     &&  
  fb = .T.                    &&  Bold
  fi = .F.                    &&  Italic 
  he = 17                     &&  
*  he = 15                     &&  
  FOR m.i = 1 TO m.np
    aColumns(m.i, 8) = aColumns(m.i, 8) + 2
  ENDFOR
ENDIF

IF inlist(m.Variant, 1, 2)
IF type('nBrowse')!= 'C'
  WAIT WINDOW '  '
  POP KEY
  RETURN
ENDIF  
IF type(nBrowse+'.Class') = 'U'
  WAIT WINDOW '   '+nBrowse
  POP KEY
  RETURN
ENDIF  
IF &nBrowse..BaseClass != 'Grid'
  WAIT WINDOW '  Grid'
  POP KEY
  RETURN
ENDIF  
  ti = iif(type('m.RepTitle')='C', m.RepTitle, wtitle())
  pa = iif(type('m.RepParam')='C', m.RepParam, '')
  pz = iif(type('m.RepEnd')='C', m.RepEnd, '')
  np = &nBrowse..ColumnCount      &&  
  fn = &nBrowse..FontName         &&  
  fs = &nBrowse..FontSize         &&  
  fb = &nBrowse..FontBold         &&  Bold
  fi = &nBrowse..FontItalic       &&  Italic 
  he = &nBrowse..RowHeight        &&  
  PRIVATE aColumns
  DIMENSION aColumns(m.np,8)
IF m.Variant = 1
  ActCol = &nBrowse..ActiveColumn 
  ActRow = &nBrowse..RelativeRow 
  LeftCol = &nBrowse..LeftColumn
  FOR m.i = 1 TO m.LeftCol - 1
    &nBrowse..DoScroll(4)
  ENDFOR
ENDIF
PRIVATE afAuto
DIMENSION afAuto(m.np)
afAuto = ''
IF m.Variant = 2
  FOR m.i = 1 TO m.np
    IF type(m.nBrowse+'.Columns(m.i).AutoFilter') = 'C'
      afAuto(m.i) = &nBrowse..Columns(m.i).AutoFilter
    ELSE
      afAuto(m.i) = '' 
    ENDIF
  ENDFOR
ENDIF
  FOR m.i = 1 TO m.np
    IF m.i != 1 AND m.Variant = 1
      &nBrowse..DoScroll(5)
    ENDIF
    aColumns(m.i,1) = &nBrowse..Columns(m.i).ControlSource
    aColumns(m.i,2) = &nBrowse..Columns(m.i).Controls(1).Caption
    aColumns(m.i,3) = &nBrowse..Columns(m.i).Width 
    tip = &aColumns(m.i,1)
    aColumns(m.i,5) = type('m.tip') 
    IF m.Variant = 1 AND type('m.tip')='N' ;
      AND &nBrowse..Columns(m.i).Controls(2).Value = 0
      j = 0
      &nBrowse..Columns(m.i).Bound = .f.      
      &nBrowse..Columns(m.i).Controls(2).ControlSource = 'm.j'      
    ENDIF
    IF m.Variant = 1
    &nBrowse..ActivateCell(m.ActRow,m.i - &nBrowse..LeftColumn + 1)
    aColumns(m.i,6) = &nBrowse..Columns(m.i).Controls(2).Text 
    aColumns(m.i,4) = &nBrowse..Columns(m.i).Controls(2).Format 
    ELSE
    aColumns(m.i,4) = &nBrowse..Columns(m.i).Format 
    ENDIF
    &nBrowse..Columns(m.i).Bound = .t.      
    aColumns(m.i,7) = 1
    aColumns(m.i,8) = &nBrowse..Columns(m.i).ColumnOrder + 2  
  ENDFOR
IF m.Variant = 1
  DO WHILE &nBrowse..LeftColumn > m.LeftCol
    &nBrowse..DoScroll(4)
  ENDDO
  &nBrowse..ActivateCell(m.ActRow,m.ActCol - m.LeftCol + 1)
ENDIF
ENDIF

IF type('m.Brick_fn') = 'C'
  fn = iif(empty(m.Brick_fn), m.fn, m.Brick_fn)
ENDIF
IF type('m.Brick_fs') = 'N'
  fs = iif(empty(m.Brick_fs), m.fs, m.Brick_fs)
ENDIF
IF type('m.Brick_fb') = 'L'
  fb = m.Brick_fb
ENDIF
IF type('m.Brick_fi') = 'L'
  fi = m.Brick_fi
ENDIF
IF type('m.Brick_orient') = 'N'
  Orient = m.Brick_orient
ENDIF
he = Fontmetric(1, m.fn, m.fs, iif(m.fb,'B','')+iif(m.fi,'I','')) ;
   + Fontmetric(4, m.fn, m.fs, iif(m.fb,'B','')+iif(m.fi,'I',''))


*SET ESCAPE OFF
*SET DELETED ON
*SET DATE TO GERMAN
*SET CENTURY ON
***
WAIT ' ...' WINDOW NOWAIT   
IF type('m.nBrick') = 'U'
  PUBLIC nBrick
  nBrick = 0
ENDIF
nBrick = m.nBrick + 1
PRIVATE nQbrick, nFsBrick
nQbrick = 'Qbrick'+ltrim(str(m.nBrick))
nFsBrick = 'oFsBr'+ltrim(str(m.nBrick)) 
PRIVATE &nFsBrick

CREATE CURSOR (nQbrick) (nRec N(10), nPop N(10), Flag C(1), Dummy C(1))
SELECT (wa)
PRIVATE wanRec
nStr = 0
SCAN
  wanRec = recno()
  SELECT (nQbrick)
  nStr = m.nStr + 1
  APPEND BLANK
  REPLACE nRec WITH m.wanRec, nPop WITH m.nStr, Flag WITH '+' 
  SELECT (wa)
ENDSCAN
nStrMax = m.nStr
SELECT (nQbrick) 
INDEX ON nRec TAG nRec
SELECT (wa)
*SET RELATION TO recno(m.wa) INTO (nQbrick) ADDITIVE
SET RELATION TO recno() INTO (nQbrick) ADDITIVE
GO TOP IN (wa) 
*_SCREEN.Visible = .T. 
*BROWSE FIELDS z=recno(), &nQbrick..nRec,  &nQbrick..nPop
*_SCREEN.Visible = .F.

np = m.np + 3
DIMENSION aColumns(m.np, 8)
= ains(aColumns, 1)
= ains(aColumns, 1)
*    aColumns(1,1) = m.nQbrick+'.Flag'
    aColumns(1,1) = 'max(fQbrick(1),"")'
    aColumns(1,2) = '+'
    aColumns(1,3) = 15 
    aColumns(1,4) = '' 
    aColumns(1,5) = 'C' 
    aColumns(1,6) = ' ' 
    aColumns(1,7) = 0 
    aColumns(1,8) = 1 

*    aColumns(2,1) = m.nQbrick+'.nPop'
    aColumns(2,1) = 'max(fQbrick(2),0)'
    aColumns(2,2) = 'N'
    aColumns(2,3) = 35 
    aColumns(2,4) = '' 
    aColumns(2,5) = 'N' 
    aColumns(2,6) = ' ' 
    aColumns(2,7) = 0 
    aColumns(2,8) = 2 

*    aColumns(m.np,1) = m.nQbrick+'.Dummy'
    aColumns(m.np,1) = 'max(fQbrick(3),"")'
    aColumns(m.np,2) = ''
    aColumns(m.np,3) = 20 
    aColumns(m.np,4) = '' 
    aColumns(m.np,5) = 'C' 
    aColumns(m.np,6) = ' ' 
    aColumns(m.np,7) = 0 
    aColumns(m.np,8) = m.np 

PRIVATE aWidth
DIMENSION aWidth(m.np)
FOR i = 1 TO alen(aWidth)
  aWidth(m.i) = 0
ENDFOR
DIMENSION afAuto(m.np)
= ains(afAuto, 1)
= ains(afAuto, 1)
afAuto(1) = ''
afAuto(2) = ''
afAuto(m.np) = ''

IF inlist(m.Variant, 2, 3)
  IF !DIRECTORY('TMP')
    MKDIR TMP
  ENDIF
  nbdpTMP = 'TMP\'+ SYS(3) +'.TXT'
  SET CONSOLE OFF
  SET PRINTER TO FILE (nbdpTMP)
  SET PRINTER ON
  FOR i = 1 TO alen(aColumns, 1)
    IF aColumns(m.i,5) = 'N' 
      j = aColumns(m.i,1)
      ?&j
    ENDIF
  ENDFOR
  SET PRINTER OFF
  SET PRINTER TO
  SET CONSOLE ON
  Handle = fopen(m.nbdpTMP)	&& Open the file
  IF m.Handle >= 0
    j = fgets(m.Handle)  && Store contents
    FOR i = 1 TO alen(aWidth)
      IF aColumns(m.i,5) = 'N' 
        aColumns(m.i,6) = fgets(m.Handle)
      ENDIF
    ENDFOR
    = fclose(m.Handle)  && Close the file
    DELETE FILE (nbdpTMP)
  ENDIF
ENDIF
SELECT (wa)
= minWidth()
nSum = 1
nSto = 0
FOR m.i = 1 TO m.np
  IF aColumns(m.i,7) = 1 
    nSum = m.nSum + aColumns(m.i,3) + 1
  ENDIF
  nSto =m.nSto + iif(aColumns(m.i,7)=0, 0, 1) 
ENDFOR

&nFsBrick = CreateObject('FormSet')
&nFsBrick..AutoRelease = .T.
&nFsBrick..AddObject('oForm', 'frmPrnBro')
&nFsBrick..WindowType = 3
Copies = 1
 
*oFsBrick.oForm.Caption = m.ti
&nFsBrick..oForm.Caption = ' !'
WITH &nFsBrick..oForm.grdPrnBro
* .ColumnCount = alen(aColumns,1)
 .RecordSource = m.wal 
 .RowHeight = m.he
 .HeaderHeight = m.he
 .ColumnCount = 0
ENDWITH

= asort(aColumns,8)
nSum = 1
FOR i = 1 TO alen(aColumns,1)
  &nFsBrick..oForm.grdPrnBro.AddObject('Column'+ltrim(str(m.i)), 'grcColumn')
  IF aColumns(m.i,7) = 1 
    nSum = m.nSum + aColumns(m.i,3) + 1
  ENDIF
  WITH &nFsBrick..oForm.grdPrnBro.Columns(m.i)
   .Init
   .ControlSource = aColumns(m.i,1)
   .Width = aColumns(m.i,3)
   .Right = m.nSum 
   .YesPrint = aColumns(m.i,7)
   .Format = aColumns(m.i,4)
   .Controls(1).Caption = aColumns(m.i,2)
*  .BackColor = iif(aColumns(m.i,7)=0,m.Yellow,m.White)
   .DynamicBackColor = "iif("+m.nQbrick+".Flag = ' ' OR "+m.nFsBrick+".oForm.grdPrnBro.Columns("+ltrim(str(m.i))+").YesPrint = 0," ;
                      +" m.Yellow, iif("+m.nFsBrick+".oForm.grdPrnBro.Columns("+ltrim(str(m.i))+").Right < m.pp, m.White, m.Blue))"
   .ColumnOrder = aColumns(m.i,8)
   .Alignment = iif(aColumns(m.i,5)='C',0,1)
   .Number = m.i
   .AutoFilter = afAuto(m.i)
   .Visible = .T.
  ENDWITH
  IF aColumns(m.i,5) = 'N' AND m.Variant = 1
    px = at('.',aColumns(m.i,6))
    py = len(aColumns(m.i,6))
    IF m.px = 0
      &nFsBrick..oForm.grdPrnBro.Columns(m.i).ControlSource = 'round('+aColumns(m.i,1)+',0)' 
    ELSE
      &nFsBrick..oForm.grdPrnBro.Columns(m.i).ControlSource = 'round('+aColumns(m.i,1)+','+ltrim(str(m.py-m.px))+')' 
    ENDIF
  ENDIF   
ENDFOR
&nFsBrick..oForm.txtPaper.left = m.winWidth - 70 + iif(m.orient = 0, 18, 5) 
&nFsBrick..oForm.txtPaper.top =  iif(m.orient = 0, 5, 13)
&nFsBrick..oForm.txtPaper.width = iif(m.orient = 0, 32, 45) 
&nFsBrick..oForm.txtPaper.height = iif(m.orient = 0, 45, 32) 
&nFsBrick..oForm.lbl1.Caption = '      '+str(m.nStr,5) 
&nFsBrick..oForm.lbl2.Caption = '   '+str(m.nSto,5) 
&nFsBrick..oForm.lbl3.Caption = ' '+str(m.nSum / m.pp,5,2)

IF inlist(m.Variant, 1, 2) OR inlist(m.Variant,3) AND empty(m.RepName) 
  rStandart = 0
  rQuick = 1
  &nFsBrick..oForm.opgReport.Visible = .F.
  &nFsBrick..oForm.opgReport.Enabled = .F.
ELSE
  rStandart = 1
  rQuick = 0
  &nFsBrick..oForm.opgReport.ButtonCount = 2
  FOR i = 1 TO 2
    WITH &nFsBrick..oForm.opgReport.Buttons(m.i)
     .Value = iif(m.i=1, 1, 0)
     .Style = 0
     .Caption = iif(m.i = 1, ' ', ' ')
     .Top = 0 + (m.i - 1) * 15
     .Left = 5
     .Height = 15
     .Width = 240
     .FontBold = .T.
    ENDWITH
  ENDFOR
ENDIF
WAIT CLEAR
&nFsBrick..oForm.Show()
***
SELECT (wa)
SET RELATION OFF INTO (nQbrick)
USE IN (nQbrick)
nBrick = m.nBrick - 1
SET FILTER TO &fOld
IF between(m.rc, 1, reccount())
  GOTO m.rc
ENDIF  
SET STATUS BAR &StatBAr
SET CENTURY &Century
POP KEY
RETURN

FUNCTION fQBrick
PARAMETER n
PRIVATE r, w, k
DO CASE
   CASE m.n = 1
     r = ''  
   CASE m.n = 2
     r = 0  
   CASE m.n = 3
     r = ''  
ENDCASE
w = select()
k = recno(m.wa)
SELECT (nQBrick)
LOCATE FOR nRec = m.k
IF found()
  DO CASE
    CASE m.n = 1
       r = Flag  
     CASE m.n = 2
       r = nPop  
     CASE m.n = 3
       r = Dummy  
  ENDCASE
ENDIF
SELECT (w)
RETURN m.r

FUNCTION minWidth
PARAMETER ii
PRIVATE rc, i, f, x, z, b
PRIVATE pf, px, py, pw, nd
PRIVATE i1, i2
rc = recno()
b = ''
b = iif(m.fb, m.b+'B', m.b)
b = iif(m.fi, m.b+'I', m.b)
b = iif(empty(m.b), 'N', m.b)
IF empty(m.ii)
  i1 = 1
  i2 = alen(aColumns, 1)
ELSE
  i1 = m.ii
  i2 = m.ii
ENDIF
FOR i = m.i1 TO m.i2
  aWidth(m.i) = 0
ENDFOR
SCAN
  FOR i = m.i1 TO m.i2
    pf = '@'+aColumns(m.i,4)+'  '
    px = at(' ', m.pf)
    IF m.px != 0
      pw = alltrim(substr(m.pf, m.px+1))
      pf = left(m.pf, m.px-1)
    ENDIF
    IF aColumns(m.i,5) = 'N'
      IF m.Variant = 1 OR inlist(m.Variant, 2, 3) AND len(m.pw) = 0
        px = at('.',aColumns(m.i,6))
        py = len(aColumns(m.i,6))
      ELSE
        px = at('.',m.pw)
        py = len(m.pw)
      ENDIF
      IF m.px = 0
        nd = 0 
      ELSE
        nd = m.py-m.px 
      ENDIF
    ENDIF   
    x = aColumns(m.i,1)
    f = '@'+aColumns(m.i,4)
    DO CASE
       CASE aColumns(m.i,5) = 'N'
         s = ltrim(str(&x, 20, m.nd))
       CASE aColumns(m.i,5) = 'C'
         s = alltrim(&x)
       CASE aColumns(m.i,5) = 'D'
         s = dtoc(&x)
    ENDCASE
    z = ceiling((txtwidth(m.s, m.fn, m.fs, m.b)+ 1) * fontmetric(6, m.fn, m.fs, m.b))
    aWidth(m.i) = max(aWidth(m.i), m.z)
  ENDFOR
ENDSCAN
FOR i = 1 TO alen(aWidth)
  s = alltrim(aColumns(m.i,2))
  z = ceiling((txtwidth(m.s, m.fn, m.fs, m.b)+ 1) * fontmetric(6, m.fn, m.fs, m.b))
  IF m.FirstTime
    aColumns(m.i,3) = min(max(aColumns(m.i,3), m.z, aWidth(m.i)), 140)
  ELSE
    aColumns(m.i,3) = max(m.z, aWidth(m.i))
  ENDIF
ENDFOR
IF between(m.rc, 1, reccount())
  GOTO m.rc
ENDIF  
FirstTime = .F.
RETURN

FUNCTION InfoPRT
  PRIVATE s, Expr
  s = ltrim(str(PRTInfo(1)))
  Expr = 'ORIENTATION='+m.s+chr(13)+chr(10)
  s = ltrim(str(PRTInfo(2)))
  Expr = m.Expr + 'PAPERSIZE='+m.s+chr(13)+chr(10) 
  s = ltrim(str(PRTInfo(3),10,1))
  Expr = m.Expr + 'PAPERLENTH='+m.s+chr(13)+chr(10)
  s = ltrim(str(PRTInfo(4),10,1))
  Expr = m.Expr + 'PAPERWIDTH='+m.s+chr(13)+chr(10)
  s = ltrim(str(PRTInfo(5)))
  Expr = m.Expr + 'SCALE='+m.s+chr(13)+chr(10) 
  s = ltrim(str(PRTInfo(6)))
  Expr = m.Expr + 'COPIES='+m.s+chr(13)+chr(10)
  s = ltrim(str(PRTInfo(7)))
  Expr = m.Expr + 'DEFAULTSOURCE='+m.s+chr(13)+chr(10)
  s = ltrim(str(PRTInfo(8)))
  Expr = m.Expr + 'PRINTQUALITY='+m.s+chr(13)+chr(10) 
  s = ltrim(str(PRTInfo(9)))
  Expr = m.Expr + 'COLOR='+m.s+chr(13)+chr(10) 
  s = ltrim(str(PRTInfo(10)))
  Expr = m.Expr + 'DUPLEX='+m.s+chr(13)+chr(10)
  s = ltrim(str(PRTInfo(11)))
  Expr = m.Expr + 'YRESOLUTION='+m.s+chr(13)+chr(10)
  s = ltrim(str(PRTInfo(12)))
  Expr = m.Expr + 'TTOPTION='+m.s+chr(13)+chr(10)
  s = ltrim(str(PRTInfo(13)))
  Expr = m.Expr + 'COLLATE='+m.s+chr(13)+chr(10)
RETURN m.Expr

FUNCTION fPaper
PRIVATE ww, s1, s2 
s1 = PRTInfo(1)
s2 = PRTInfo(2)
DO CASE 
   CASE m.s1 = -1
     WAIT '  ' WINDOW
     ww = 210
     pp = 750
     paper = '??'
     orient = 0
   CASE m.s2 = 8    && A3
     ww = iif(m.s1 = 0, 297, 420)  
     pp = iif(m.s1 = 0, 1080, 1550)
     paper = 'A3'
     orient = m.s1   
   CASE m.s2 = 9    && A4 
     ww = iif(m.s1 = 0, 210, 297)  
*     pp = iif(m.s1 = 0, 750, 1080)
     pp = iif(m.s1 = 0, 750, 1070)
     paper = 'A4'
     orient = m.s1
   CASE m.s2 = 260  && A3T
     ww = iif(m.s1 = 0, 420, 297)  
     pp = iif(m.s1 = 0, 1550, 1080)
     paper = 'A3'
     orient = iif(m.s1 = 0, 1, 0)   
   CASE m.s2 = 261  && A4T 
     ww = iif(m.s1 = 0, 297, 210)  
*     pp = iif(m.s1 = 0, 1080, 750)
     pp = iif(m.s1 = 0, 1080, 740)
     paper = 'A4'
     orient = iif(m.s1 = 0, 1, 0)   
   CASE m.s2 = 11   && A5 
     ww = iif(m.s1 = 0, 148, 210)  
     pp = iif(m.s1 = 0, 540, 750)
     paper = 'A5'
     orient = m.s1
   CASE m.s2 = 256  && 
     ww = iif(m.s1 = 0, PRTInfo(4), PRTInfo(3))  
     pp = int(iif(m.s1 = 0, PRTInfo(4), PRTInfo(3)) / 210 * 800 - 50)
     paper = '??'
     orient = 0
   CASE m.s2 = -1   && 
     ww = iif(m.s1 = 0, PRTInfo(4), PRTInfo(3))  
     pp = int(iif(m.s1 = 0, PRTInfo(4), PRTInfo(3)) / 210 * 800 - 50)
     paper = '??'
     orient = 0
   OTHERWISE
     WAIT '  ' WINDOW
     ww = 210  
     pp = 750
     paper = '??'
     orient = 0
ENDCASE
RETURN

DEFINE CLASS grcColumn AS Column 
 FontName = 'Times New Roman' 
 FontSize = 9 
 FontBold = .T. 
 Format = '@Z' 
 ReadOnly = .T.
 Enabled = .T. 
 Visible = .T.
 AutoFilter = '' 
 fFlt0 = 1
 vFlt0 = ''
 fFlt1 = 1
 vFlt1 = ''
 fFlt2 = 1
 vFlt2 = ''
 xFlt = 0
 pText = ''
 pF1 = .T.
 pF2 = .F.
 pF3 = .T.
 Right = 0
 Number = 0
 YesPrint = 1
PROCEDURE Init
 This.FontSize =  m.fs 
 This.FontBold =  m.fb 
 This.FontItalic = m.fi 
*This.Format = '@Z' 
 This.ReadOnly = .T. 
 This.FontName = m.fn 
 This.Header1.Alignment = 2 
 This.Header1.FontSize =  m.fs 
 This.Header1.FontBold =  m.fb 
 This.Header1.FontItalic = m.fi 
 This.Header1.FontName = m.fn 
 This.Right = 0
ENDPROC
  PROCEDURE Resize
    LOCAL i
    nSum = 1  
    FOR i = 1 TO alen(aColumns,1)
      IF aColumns(m.i,5) = 'N'
        aColumns(m.i,3) = max(ThisForm.grdPrnBro.Columns(m.i).Width, aWidth(m.i))
      ELSE
        aColumns(m.i,3) = ThisForm.grdPrnBro.Columns(m.i).Width
      ENDIF
      ThisForm.grdPrnBro.Columns(m.i).Width = aColumns(m.i,3)
      IF aColumns(m.i,7) = 1 
        nSum = m.nSum + ThisForm.grdPrnBro.Columns(m.i).Width + 1
        ThisForm.grdPrnBro.Columns(m.i).Right = m.nSum
      ENDIF
    ENDFOR
    ThisForm.lbl3.Caption = ' '+str(m.nSum / m.pp,5,2)
  ENDPROC
  ADD OBJECT header1 AS grhHeader
  ADD OBJECT text1 AS grcText
  CurrentControl = 'text1'
ENDDEFINE
DEFINE CLASS grcText AS TextBox 
 Visible = .T.
 BorderStyle = 0
PROCEDURE RightClick
  PRIVATE grcName, grdName, MenuName
  grcName = This.Parent
  grdName = This.Parent.Parent
  MenuName = grdName.prgMenu
  IF !empty(m.MenuName)
    = &MenuName(m.grdName, m.grcName)
  ENDIF
ENDPROC
ENDDEFINE
DEFINE CLASS grhHeader AS Header
 Visible = .T.
 FontName = 'Times New Roman' 
 FontSize = 9 
 FontBold = .T. 
 Alignment = 2 
PROCEDURE RightClick
  PRIVATE grcName, grdName, MenuName
  grcName = This.Parent
  grdName = This.Parent.Parent
  MenuName = grdName.prgMenu
  IF !empty(m.MenuName)
    = &MenuName(m.grdName, m.grcName)
  ENDIF
ENDPROC
PROCEDURE DblClick
  nColumn = This.Parent.Number
  ThisForm.cmd3.Click
ENDPROC
ENDDEFINE 

DEFINE CLASS frmPrnBro AS Form
  ScaleMode = 3
  Height = m.winHeight   && 460
  Width = m.winWidth     && 780
  AutoCenter = .T.
  MaxButton = .F.
  MinButton = .T.
*  Closable = .T.
  Closable = .F.
  ControlBox = .F.
*  Movable = .F.
  Movable = .T.
  WindowType = 1
  ShowWindow = 1
  ShowTips = .T.
  MinWidth = 780
  MinHeight = 460

 PROCEDURE Resize
   WinHeight = ThisForm.Height
   WinWidth = ThisForm.Width

   ThisForm.grdPrnBro.Height = m.winHeight - 160  
   ThisForm.grdPrnBro.Width = m.winWidth - 40  
   ThisForm.txtTitle.Width = m.winWidth - 260  
   ThisForm.cmdBegin.Left = m.winWidth - 220  
   ThisForm.cmdEnd.Left = m.winWidth - 110  
   ThisForm.lbl01.Left = m.winWidth - 510  
   ThisForm.txtPage.Left = m.winWidth - 280  
   ThisForm.lbl1.Left = m.winWidth - 210  
   ThisForm.lbl2.Left = m.winWidth - 210  
   ThisForm.lbl3.Left = m.winWidth - 210  
   ThisForm.cmdPreView.Top = m.winHeight - 50  
   ThisForm.cmdPrint.Top = m.winHeight - 50  
   ThisForm.spnCopies.Top = m.winHeight - 37  
   ThisForm.lblCopies.Top = m.winHeight - 55  
   ThisForm.cmdParam.Top = m.winHeight - 50  
   ThisForm.cmdFont.Top = m.winHeight - 50  
   ThisForm.cmdExcel.Top = m.winHeight - 50  
   ThisForm.cmdOK.Top = m.winHeight - 50  
   ThisForm.cmdOK.Left = m.winWidth - 110  
   ThisForm.txtPaper.left = m.WinWidth - 70 + iif(m.orient = 0, 18, 5) 

   ThisForm.Refresh
 ENDPROC

  ADD OBJECT grdPrnBro AS Grid WITH ;
    FontName = 'Times New Roman', ;
    FontSize = 12, ;
    FontBold = .T., ;
    Top = 90, ;
    Left = 20, ;
    Height = m.winHeight - 160, ;
    Width = m.winWidth - 40, ;
    DeleteMark = .F., ;
    TabStop = .T., ;
    prgMenu = 'b_Menu'
    
  ADD OBJECT txtPaper AS TextBox WITH ;
    ControlSource = 'm.paper', ;
    FontName = 'Times New Roman', ;
    FontSize = 14, ;
    FontBold = .T., ;
    ReadOnly = .T., ;
    DisabledBackColor = m.White, ;
    ToolTipText = ' '
    
  ADD OBJECT txtTitle AS TextBox WITH ;
    ControlSource = 'm.ti', ;
    FontName = 'Times New Roman', ;
    FontSize = 11, ;
    FontBold = .T., ;
    Top = 55, ;
    Left = 20, ;
    Height = 25, ;
    Width = m.winWidth - 260, ;
    ToolTipText = ' '

  ADD OBJECT cmdBegin AS CommandButton WITH ;
    Caption = '', ;
    FontName = 'Times New Roman', ;
    FontSize = 10, ;
    FontBold = .T., ;
    Top = 55, ;
    Left = m.winWidth - 220, ;
    Height = 25, ;
    Width = 90, ;
    ToolTipText = ' '
  ADD OBJECT cmdEnd AS CommandButton WITH ;
    Caption = '', ;
    FontName = 'Times New Roman', ;
    FontSize = 10, ;
    FontBold = .T., ;
    Top = 55, ;
    Left = m.winWidth - 110, ;
    Height = 25, ;
    Width = 90, ;
    ToolTipText = ' '


 ADD OBJECT lbl01 AS Label WITH ;
    Caption = '   ', ;
    FontName = 'Courier New', ;
    FontSize = 10, ;
    FontBold = .T., ;
    Top = 2, ;
    Left = m.winWidth - 510, ;
    Height = 15, ;
    Width = 240
  ADD OBJECT txtPage AS TextBox WITH ;
    ControlSource = 'm.FirstPage', ;
    FontName = 'Times New Roman', ;
    FontSize = 10, ;
    FontBold = .T., ;
    Top = 0, ;
    Left = m.winWidth - 280, ;
    Height = 20, ;
    Width = 40, ;
    InputMask = '9999', ;
    ToolTipText = '  '

   ADD OBJECT opgReport AS OptionGroup WITH ;
    BorderStyle = 0, ;
    FontName = 'Times New Roman', ;
    FontSize = 10, ;
    Top = 20, ;
    Left = 270, ;
    Height = 35, ;
    Width = 240

   ADD OBJECT lbl1 AS Label WITH ;
    Caption = '      '+str(m.nStr,5), ;
    FontName = 'Courier New', ;
    FontSize = 10, ;
    FontBold = .T., ;
    Top = 2, ;
    Left = m.winWidth - 210, ;
    Height = 15, ;
    Width = 130

  ADD OBJECT lbl2 AS Label WITH ;
    Caption = '   '+str(m.nSto,5), ;
    FontName = 'Courier New', ;
    FontSize = 10, ;
    FontBold = .T., ;
    Top = 17, ;
    Left = m.winWidth - 210, ;
    Height = 15, ;
    Width = 130

  ADD OBJECT lbl3 AS Label WITH ;
    Caption = ' '+str(m.nSum / m.pp,5,2), ;
    FontName = 'Courier New', ;
    FontSize = 10, ;
    FontBold = .T., ;
    Top = 35, ;
    Left = m.winWidth - 210, ;
    Height = 15, ;
    Width = 130

  ADD OBJECT cmd1 AS CommandButton WITH ;
    Caption = '', ;
    Picture = 'main\paper1.bmp' ,;
    FontName = 'Times New Roman', ;
    FontSize = 10, ;
    FontBold = .T., ;
    Top = 5, ;
    Left = 20, ;
    Height = 32, ;
    Width = 32, ;
    ToolTipText = '  '

  ADD OBJECT cmd2 AS CommandButton WITH ;
    Caption = '', ;
    Picture = 'main\paper2.bmp' ,;
    FontName = 'Times New Roman', ;
    FontSize = 10, ;
    FontBold = .T., ;
    Top = 5, ;
    Left = 60, ;
    Height = 32, ;
    Width = 32, ;
    ToolTipText = '      '

  ADD OBJECT cmd3 AS CommandButton WITH ;
    Caption = '', ;
    Picture = 'main\paper3.bmp' ,;
    FontName = 'Times New Roman', ;
    FontSize = 10, ;
    FontBold = .T., ;
    Top = 5, ;
    Left = 100, ;
    Height = 32, ;
    Width = 32, ;
    ToolTipText = '    '

  ADD OBJECT cmdPreView AS CommandButton WITH ;
    Caption = '', ;
    FontName = 'Times New Roman', ;
    FontSize = 12, ;
    FontBold = .T., ;
    Top = m.WinHeight - 50, ;
    Left = 20, ;
    Height = 40, ;
    Width = 90, ;
    ToolTipText = ' '

  ADD OBJECT cmdPrint AS CommandButton WITH ;
    Caption = '', ;
    FontName = 'Times New Roman', ;
    FontSize = 12, ;
    FontBold = .T., ;
    Top = m.WinHeight - 50, ;
    Left = 130, ;
    Height = 40, ;
    Width = 90, ;
    ToolTipText = ' '

  ADD OBJECT spnCopies AS Spinner WITH ;
    FontName = 'Times New Roman', ;
    FontSize = 11, ;
    FontBold = .T., ;
    ControlSource = 'Copies', ;
    KeyboardHighValue = 10, ;
    KeyboardLowValue = 1, ;
    SpinnerHighValue = 10, ;
    SpinnerLowValue = 1, ;
    Top = m.WinHeight - 37, ;
    Left = 240, ;
    Height = 23, ;
    Width = 50, ;
    ToolTipText = ' '

  ADD OBJECT lblCopies AS Label WITH ;
    Caption = '', ;
    FontName = 'Times New Roman', ;
    FontSize = 11, ;
    FontBold = .T., ;
    Top = m.WinHeight - 55, ;
    Left = 240, ;
    Height = 18, ;
    Width = 50

  ADD OBJECT cmdParam AS CommandButton WITH ;
    Caption = '', ;
    FontName = 'Times New Roman', ;
    FontSize = 12, ;
    FontBold = .T., ;
    Top = m.WinHeight - 50, ;
    Left = 310, ;
    Height = 40, ;
    Width = 90, ;
    ToolTipText = ' '

  ADD OBJECT cmdFont AS CommandButton WITH ;
    Caption = '', ;
    FontName = 'Times New Roman', ;
    FontSize = 12, ;
    FontBold = .T., ;
    Top = m.WinHeight - 50, ;
    Left = 420, ;
    Height = 40, ;
    Width = 90, ;
    ToolTipText = ''

  ADD OBJECT cmdExcel AS CommandButton WITH ;
    Caption = '', ;
    FontName = 'Times New Roman', ;
    FontSize = 12, ;
    FontBold = .T., ;
    Top = m.WinHeight - 50, ;
    Left = 530, ;
    Height = 40, ;
    Width = 90, ;
    ToolTipText = ''

  ADD OBJECT cmdOK AS CommandButton WITH ;
    Caption = '', ;
    FontName = 'Times New Roman', ;
    FontSize = 12, ;
    FontBold = .T., ;
    Top = m.WinHeight - 50, ;
    Left = m.WinWidth - 110, ;
    Height = 40, ;
    Width = 90, ;
    Cancel = .T., ;
    ToolTipText = ''

  
  PROCEDURE grdPrnBro.Valid
    LOCAL i, j
    j = This.ActiveColumn
    FOR i = 1 TO This.ColumnCount
      IF This.Columns(m.i).ColumnOrder = m.j
        nColumn = m.i
        EXIT
      ENDIF
    ENDFOR
  ENDPROC

  PROCEDURE txtPage.LostFocus
    ThisForm.grdPrnBro.SetFocus
  ENDPROC
  PROCEDURE txtTitle.LostFocus
    ThisForm.grdPrnBro.SetFocus
  ENDPROC
  PROCEDURE spnCopies.LostFocus
    ThisForm.grdPrnBro.SetFocus
  ENDPROC

  PROCEDURE OpgReport.Click
    IF This.Buttons(1).Value != 0
      rQuick = 0
      rStandart = 1
    ELSE    
     rQuick = 1
     rStandart = 0
    ENDIF
    ThisForm.grdPrnBro.SetFocus
  ENDPROC  

  PROCEDURE cmdBegin.Click
    pa = EditText(m.pa, '')
  ENDPROC
  PROCEDURE cmdEnd.Click
    pz = EditText(m.pz, '')
  ENDPROC
  PROCEDURE cmd1.Click
    LOCAL n
    SELECT (wa)
    n = recno()
    SCAN
      SELECT (nQbrick)
      REPLACE Flag WITH '+'
      SELECT (wa)
    ENDSCAN    
    IF m.n < reccount()
      GO m.n
    ENDIF  
    nStr = m.nStrMax
    ThisForm.lbl1.Caption = '     '+str(m.nStr,5)
    ThisForm.grdPrnBro.SetFocus
  ENDPROC  

  PROCEDURE cmd2.Click
    LOCAL n, f
    nStr = 0
    SELECT (wa)
    n = recno()
    f = .F.
    SCAN 
      IF recno() = m.n
        f = .T.
      ENDIF 
      IF m.f
        SELECT (nQbrick)
        REPLACE Flag WITH iif(Flag = '+', ' ', '+')
      ENDIF
      nStr = m.nStr + iif(&nQbrick..Flag = '+', 1, 0)
      SELECT (wa)
    ENDSCAN
    ThisForm.lbl1.Caption = '     '+str(m.nStr,5)
    IF m.n < reccount()
      GO m.n
    ENDIF  
    ThisForm.grdPrnBro.SetFocus
  ENDPROC  

  PROCEDURE cmd3.Click
    LOCAL i
    i = m.nColumn
    IF m.i != 1
      aColumns(m.i,7) = iif(aColumns(m.i,7)=0,1,0)
      nSto = m.nSto + iif(aColumns(m.i,7)=0, -1, 1)
      ThisForm.lbl2.Caption = '   '+str(m.nSto,5)
    ENDIF
    ThisForm.grdPrnBro.Columns(m.i).YesPrint = aColumns(m.i,7)   
    nSum = 1
    FOR i = 1 TO m.np
      IF aColumns(m.i,7) = 1 
        nSum = m.nSum + ThisForm.grdPrnBro.Columns(m.i).Width + 1
        ThisForm.grdPrnBro.Columns(m.i).Right = m.nSum
        ThisForm.grdPrnBro.Columns(m.i).DynamicBackColor = ;
              "iif("+m.nQbrick+".Flag = ' ' OR "+m.nFsBrick+".oForm.grdPrnBro.Columns("+ltrim(str(m.i))+").YesPrint = 0," ;
             +" m.Yellow, iif("+m.nFsBrick+".oForm.grdPrnBro.Columns("+ltrim(str(m.i))+").Right < m.pp, m.White, m.Blue))"
      ENDIF
    ENDFOR
    ThisForm.lbl3.Caption = ' '+str(m.nSum / m.pp,5,2)
    ThisForm.grdPrnBro.SetFocus
  ENDPROC  

  PROCEDURE cmdExcel.Click
     LOCAL nFile, oFexp, oForm, nRec,fSafety, w 
     PRIVATE aExp, nExp, fExp
     DIMENSION aExp(5)
     fExp = .T.
     w = ThisForm.grdPrnBro.RecordSource
     aExp(1) = 'Excel- '
     aExp(2) = 'Excel'
     aExp(3) = 'Excel 5'
     aExp(4) = 'FoxPro 2x'
     aExp(5) = 'Visual FoxPro'
     nExp = 1
     oFexp = CreateObject('FormSet')
     oFexp.WindowType = 3
     oFexp.AutoRelease = .T.
     oFexp.AddObject('oForm', 'frmLExp')
     oFexp.oForm.Show()

     IF m.nExp = 0
       ThisForm.grdPrnBro.SetFocus
       RETURN
     ENDIF 
     fSafety = set('SAFETY')
     SET SAFETY ON
     DO CASE 
        CASE m.nExp = 1
          nFile = getfile(' Excel:XLS')
          IF !empty(m.nFile)
            SELECT (w)
            nRec = recno()
            = fExBrick(ThisForm.grdPrnBro, nFile, @aColumns, m.ti, m.pa, m.pz)
          ENDIF
        CASE m.nExp = 2
          nFile = getfile(' Excel:XLS')
          IF !empty(m.nFile)
            SELECT (w)
            nRec = recno()
            COPY TO (nFile) TYPE XLS
          ENDIF
        CASE m.nExp = 3
          nFile = getfile(' Excel5:XLS')
          IF !empty(m.nFile)
            SELECT (w)
            nRec = recno()
            COPY TO (nFile) TYPE XL5
          ENDIF
        CASE m.nExp = 4
          nFile = getfile(' Fox2x:DBF')
          IF !empty(m.nFile)
            SELECT (w)
            nRec = recno()
            COPY TO (nFile) TYPE FOX2X AS 866
          ENDIF
        CASE m.nExp = 5
          nFile = getfile(' VFP:DBF')
          IF !empty(m.nFile)
            SELECT (w)
            nRec = recno()
            COPY TO (nFile) 
          ENDIF
     ENDCASE
    SET SAFETY &fSafety
    IF m.nRec <= reccount()
      GO m.nRec
    ENDIF  
    ThisForm.grdPrnBro.SetFocus
  ENDPROC  

  PROCEDURE cmdOK.Click
    ThisForm.Release
  ENDPROC  

  PROCEDURE cmdFont.Click
    LOCAL s, i1, i2, s1, s2, s3, oldw, neww
    oldw = Fontmetric(6, m.fn, m.fs, ;
           iif(m.fb OR m.fi,'','N')+iif(m.fb,'B','')+iif(m.fi,'I',''))
    s = getFont() 
    IF !empty(m.s)
      i1 = at(',', m.s,1)
      i2 = at(',', m.s,2)
      s1 = substr(m.s,1,m.i1-1)
      s2 = substr(m.s,m.i1+1,m.i2-1)        
      s3 = substr(m.s,m.i2+1)        
      WITH ThisForm.grdPrnBro 
       .SetAll('FontName', m.s1, 'grcColumn') 
       .SetAll('FontSize', val(m.s2), 'grcColumn') 
       .SetAll('FontBold', at('B',m.s3)!=0, 'grcColumn') 
       .SetAll('FontItalic', at('I',m.s3)!=0, 'grcColumn') 
       .SetAll('FontName', m.s1, 'grhHeader') 
       .SetAll('FontSize', val(m.s2), 'grhHeader') 
       .SetAll('FontBold', at('B',m.s3)!=0, 'grhHeader')      
       .SetAll('FontItalic', at('I',m.s3)!=0, 'grhHeader') 
       .RowHeight    = Fontmetric(1, m.s1, val(m.s2), m.s3) ;
                     + Fontmetric(4, m.s1, val(m.s2), m.s3)
       .HeaderHeight = Fontmetric(1, m.s1, val(m.s2), m.s3) ;
                     + Fontmetric(4, m.s1, val(m.s2), m.s3)
      ENDWITH
      neww = Fontmetric(6, m.s1, val(m.s2), m.s3)
      fn = m.s1
      fs = val(m.s2)
      fb = at('B',m.s3)!=0 
      fi = at('I',m.s3)!=0 
      he = Fontmetric(1, m.s1, val(m.s2), m.s3) ;
         + Fontmetric(4, m.s1, val(m.s2), m.s3)
      LOCAL i
      nSum = 1  
      = minWidth()
      FOR i = 1 TO alen(aColumns,1)
        IF aColumns(m.i,5) = 'N'
          ThisForm.grdPrnBro.Columns(m.i).Width = aColumns(m.i,3)
        ELSE
          ThisForm.grdPrnBro.Columns(m.i).Width = int(ThisForm.grdPrnBro.Columns(m.i).Width * m.neww / oldw)
        ENDIF
        aColumns(m.i,3) = ThisForm.grdPrnBro.Columns(m.i).Width
        IF aColumns(m.i,7) = 1 
          nSum = m.nSum + ThisForm.grdPrnBro.Columns(m.i).Width + 1
          ThisForm.grdPrnBro.Columns(m.i).Right = m.nSum
        ENDIF
      ENDFOR
      ThisForm.lbl3.Caption = ' '+str(m.nSum / m.pp,5,2)
    ENDIF
    ThisForm.grdPrnBro.ScrollBars = 3
    ThisForm.grdPrnBro.SetFocus
  ENDPROC  

  PROCEDURE cmdPreView.Click
    LOCAL i, Info
    PRIVATE kt, ktx, ktt, w
    kt = sys(3)
    ktx = m.kt+'.FRX'
    ktt = m.kt+'.FRT'
    IF m.rQuick = 1
      PRIVATE bColumns
      FOR m.i = 1 TO m.np
        aColumns(m.i,3) = ThisForm.grdPrnBro.Columns(m.i).Width 
      ENDFOR 
      DIMENSION bColumns(m.np,2)
      FOR i = 1 TO m.np
        bColumns(m.i,1) = ThisForm.grdPrnBro.Columns(m.i).ColumnOrder
        bColumns(m.i,2) = m.i
      ENDFOR
      = asort(bColumns, 1)
      
    WAIT WINDOW ' ' NOWAIT
    LOCAL hs, j, jj, kField
    PRIVATE kPage
      j = 1
      kPage = 1
      hS = 1
      kField = 1
      DO WHILE m.j <= m.np 
        jj = bColumns(m.j, 2)
        IF aColumns(m.jj,7) = 0 OR aColumns(m.jj,3) < 6
          j = m.j + 1 
          LOOP
        ENDIF
        IF m.hS + min(m.pp-2, aColumns(m.jj,3)) + 1 > m.pp
          = prnQuick(m.kPage, m.kField, m.j-1)
          w = ThisForm.grdPrnBro.RecordSource
          SELECT (w)
          = wBrew(0)
          WAIT WINDOW ' ' NOWAIT
          hs = 1
          kPage = m.kPage + 1
          kField = m.j 
        ENDIF  
        hs = m.hs + min(m.pp-2, aColumns(m.jj,3)) + 1
        j = m.j + 1
      ENDDO
      IF m.j - m.kField > 1 
        = prnQuick(m.kPage, m.kField, m.j-1)
          w = ThisForm.grdPrnBro.RecordSource
          SELECT (w)
        = wBrew(0)
      ENDIF
    ELSE
      = prnStand()
          w = ThisForm.grdPrnBro.RecordSource
          SELECT (w)
        = wBrew(0)
    ENDIF
    WAIT CLEAR
    ThisForm.grdPrnBro.SetFocus
  ENDPROC
  PROCEDURE cmdPrint.Click
    LOCAL i, Info
    PRIVATE kt, ktx, ktt, w
    kt = sys(3)
    ktx = m.kt+'.FRX'
    ktt = m.kt+'.FRT'
    IF m.rQuick = 1
      PRIVATE bColumns
      FOR m.i = 1 TO m.np
        aColumns(m.i,3) = ThisForm.grdPrnBro.Columns(m.i).Width 
      ENDFOR 
      DIMENSION bColumns(m.np,2)
      FOR i = 1 TO m.np
        bColumns(m.i,1) = ThisForm.grdPrnBro.Columns(m.i).ColumnOrder
        bColumns(m.i,2) = m.i
      ENDFOR
      = asort(bColumns, 1)

    WAIT WINDOW ' ' NOWAIT
    LOCAL hs, j, jj, kField
    PRIVATE kPage
      j = 1
      kPage = 1
      hS = 1
      kField = 1
      DO WHILE m.j <= m.np 
        jj = bColumns(m.j, 2)
        IF aColumns(m.jj,7) = 0 OR aColumns(m.jj,3) < 6
          j = m.j + 1 
          LOOP
        ENDIF
        IF m.hS + min(m.pp-2, aColumns(m.jj,3)) + 1 > m.pp
          = prnQuick(m.kPage, m.kField, m.j-1)
          w = ThisForm.grdPrnBro.RecordSource
          SELECT (w)
          = wBrew(1)
          hs = 1
          kPage = m.kPage + 1
          kField = m.j 
        ENDIF  
        hs = m.hs + min(m.pp-2, aColumns(m.jj,3)) + 1
        j = m.j + 1
      ENDDO
      IF m.j - m.kField > 1 
        = prnQuick(m.kPage, m.kField, m.j-1)
          w = ThisForm.grdPrnBro.RecordSource
          SELECT (w)
        = wBrew(1)
      ENDIF
    ELSE
      = prnStand()
      w = ThisForm.grdPrnBro.RecordSource
      SELECT (w)
      = wBrew(1)
    ENDIF
    WAIT CLEAR
    ThisForm.grdPrnBro.SetFocus
  ENDPROC
  PROCEDURE cmdParam.Click
  = sys(1037)
  = fPaper()
  ThisForm.txtPaper.left = m.WinWidth - 70 + iif(m.orient = 0, 18, 5) 
  ThisForm.txtPaper.top =  iif(m.orient = 0, 5, 13)
  ThisForm.txtPaper.width = iif(m.orient = 0, 32, 45) 
  ThisForm.txtPaper.height = iif(m.orient = 0, 45, 32) 
  ThisForm.txtPaper.Refresh
  ThisForm.lbl3.Caption = ' '+str(m.nSum / m.pp,5,2)
  ThisForm.grdPrnBro.SetFocus
  ENDPROC
ENDDEFINE  

DEFINE CLASS frmLExp AS Form
  Caption = ''
  ScaleMode = 3
  Height = 200
  Width = 180
  AutoCenter = .T.
  MaxButton = .F.
  MinButton = .T.
*  Closable = .T.
  Closable = .F.
  ControlBox = .F.
  Movable = .F.
  WindowType = 1
  ShowWindow = 1
  ShowTips = .T.
  
  ADD OBJECT lstList AS ListBox WITH ;
    FontName = 'Times New Roman', ;
    FontSize = 12, ;
    FontBold = .T., ;
    Top = 0, ;
    Left = 10, ;
    Height = 150, ;
    Width = 160, ;
    Style = 2, ;
    RowSourceType = 5, ; 
    RowSource = 'aExp', ;
    ColumnCount = 1, ;
    ColumnWidth = '140', ;
    BoundColumn = 1, ;
    ControlSource = 'm.nExp'
  ADD OBJECT cmdCancel AS CommandButton WITH ;
    Caption = '', ;
    FontName = 'Times New Roman', ;
    FontSize = 12, ;
    FontBold = .T., ;
    Top = 160, ;
    Left = 10, ;
    Height = 30, ;
    Width = 70, ;
    Cancel = .T., ;
    ToolTipText = ''
  ADD OBJECT cmdOK AS CommandButton WITH ;
    Caption = '', ;
    FontName = 'Times New Roman', ;
    FontSize = 12, ;
    FontBold = .T., ;
    Top = 160, ;
    Left = 100, ;
    Height = 30, ;
    Width = 70, ;
    Default = .T., ;
    ToolTipText = ''
  PROCEDURE cmdCancel.Click
     nExp = 0
     ThisForm.Release
  ENDPROC  
  PROCEDURE cmdOK.Click
     ThisForm.Release
  ENDPROC  
  PROCEDURE lstList.DblClick
     ThisForm.Release
  ENDPROC  
ENDDEFINE


*The object type is identified by the following values:
*1	Report
*2	Workarea
*3	Index
*4	Relation
*5	Text
*6	Line
*7	Box
*8	Repfield
*9	Bandinfo
*     ObjCode = 0   Title         ht       hb
*     ObjCode = 1   Page Header   hx+he+he hb
*     ObjCode = 2   Column Header 0        hb
*     ObjCode = 3   Group Header  0        hb
*     ObjCode = 4   Detail        he       hb
*     ObjCode = 5   Group Footer  he       hb
*     ObjCode = 6   Column Footer 0        hb
*     ObjCode = 7   Page Footer   he       hb
*     ObjCode = 8   Summary
*10	Group 
*17	Picture
*18	Variable
*21	Printer Driver Setup
*25	Data Environment
*26	Cursor Object

  PROCEDURE wBrew
    PARAMETER p
    PRIVATE i 
      IF m.p = 0
        _SCREEN.Visible = .T.
        DEFINE WINDOW wBrew FROM 0,0 TO 24,79 SYSTEM CLOSE TITLE '' 
        ZOOM WINDOW wBrew MAX
*       MODIFY REPORT (m.ktx) 
        REPORT FORM (m.ktx) Preview WINDOW wBrew FOR &nQbrick..Flag = '+'
        RELEASE WINDOW wBrew
        _SCREEN.Visible = .F.
        DELETE FILE (m.ktx)
        DELETE FILE (m.ktt)
      ELSE
        FOR i = 1 TO m.Copies
          REPORT FORM (m.ktx) TO PRINTER PROMPT NOCONSOLE FOR &nQbrick..Flag = '+' 
        ENDFOR
        DELETE FILE (m.ktx)
        DELETE FILE (m.ktt)
      ENDIF
  ENDPROC

FUNCTION PrnStand
PRIVATE kf, wa, i, j, arry, Info
PRIVATE Koeff, hx, ht
PRIVATE h0, h1, h2, h3, h4, h5, h6, h7, h8
kf = m.RepName

wa = select()
SELECT 0
USE (m.kf) ALIAS Rpt1 AGAIN
COPY STRUCTURE TO (m.ktx)
SELECT 0
USE (m.ktx) ALIAS Rpt2 
Koeff = 10000 / 96       && 1 Pixel  
ht = 0                   &&  
*Info = InfoPRT()
SELECT Rpt1
SCAN 
*  IF recno() = 1
*    REPLACE Expr WITH m.Info
*  ENDIF
  SCATTER MEMO TO arry
  DO CASE
     CASE Objtype = 9 AND ObjCode = 0
       SELECT Rpt2
       APPEND BLANK
       GATHER MEMO FROM arry
       ht = Height
       IF m.FirstPage > 1
         REPLACE Height WITH 0
       ENDIF
     CASE inlist(Objtype, 5, 6, 7, 8, 17)
       IF m.FirstPage > 1
         IF Vpos > m.ht
           SELECT Rpt2
           APPEND BLANK
           GATHER MEMO FROM arry
           REPLACE Vpos WITH Vpos - m.ht
         ENDIF
       ELSE
         SELECT Rpt2
         APPEND BLANK
         GATHER MEMO FROM arry
       ENDIF
     OTHERWISE
       SELECT Rpt2
       APPEND BLANK
       GATHER MEMO FROM arry
  ENDCASE
  SELECT Rpt1
ENDSCAN
USE IN Rpt1
USE IN Rpt2
SELECT (wa)
RETURN

FUNCTION PrnQuick
PARAMETERS kPage, kPar1, kPar2
PRIVATE kf, wa, i, j, arry, Info
PRIVATE Koeff, hb, hx, ht
PRIVATE Hp, Com, Hsum, pf, px, py, pw
DIMENSION aColumns(m.np,8)
DIMENSION bColumns(m.np,2)

kf = 'Quick.frx'
IF !file(m.kf)
  kf = 'main\Quick.frx'
  IF !file(m.kf)
    WAIT WINDOW '   '+ 'Quick.frx'
    RETURN
  ENDIF
ENDIF
*kt = sys(3)
*ktx = m.kt+'.FRX'
*ktt = m.kt+'.FRT'
wa = select()
SELECT 0
USE (m.kf) ALIAS Rpt1 AGAIN
COPY STRUCTURE TO (m.ktx)
SELECT 0
USE (m.ktx) ALIAS Rpt2 
Koeff = 10000 / 96       && 1 Pixel  
hb = 19                  &&    
hx = 10                  &&      
IF m.FirstPage = 1
  ht = 45                  &&  
ELSE
  ht = 0                   &&  
ENDIF
h0 = m.hb
h1 = m.hb
h2 = 0
h3 = m.hb
h4 = m.hb
h5 = m.hb
h6 = 0
h7 = m.hb
h8 = 0

Info = InfoPRT()
SELECT Rpt1
SCAN 
  Com = Comment
  Hp = Hpos
  SCATTER MEMO TO arry
  SELECT Rpt2
  IF recno() = 1
    REPLACE Expr WITH m.Info
  ENDIF
  IF inlist(m.Com, 'Title', 'Header', 'Column', 'Left1line', ;
            'Left2line', 'Hor1line', 'Hor2line', 'Hor3line', ;
            'PageHeader', 'Date', 'Group') 
    IF m.Com = 'PageHeader'
      APPEND BLANK
      GATHER MEMO FROM arry
      REPLACE Vpos WITH (m.ht+m.h0+m.hx+2)*m.Koeff 
      REPLACE Expr WITH '".' + iif(m.kPage>1, str(m.kPage,4)+' -','') ;
                +'"' + '+str(m.FirstPage +_pageno -1, 4)+' + '"' + space(10) ;
                + chrtran(m.ti, '"', "'") + '"'
      REPLACE SupExpr WITH 'm.kPage > 1 OR m.FirstPage +_pageno -1 > 1'
    ENDIF
    IF m.Com = 'Left1line'
      APPEND BLANK
      GATHER MEMO FROM arry
      REPLACE Vpos WITH (m.ht+m.h0+m.hx+m.he)*m.Koeff 
      REPLACE Height WITH m.He*m.Koeff 
    ENDIF
    IF m.Com = 'Left2line'
      APPEND BLANK
      GATHER MEMO FROM arry
      REPLACE Vpos WITH (m.ht+m.h0+m.hx+m.He+m.He+m.h1+m.h3)*m.Koeff 
      REPLACE Height WITH m.He*m.Koeff 
    ENDIF
    IF m.Com = 'Group'
      IF !empty(m.pz) AND m.kPage = 1
        APPEND BLANK
        GATHER MEMO FROM arry
        REPLACE Vpos WITH (m.ht+m.h0+m.hx+m.He+m.He+m.h1+m.h3+m.He+m.h4+1)*m.Koeff 
      ENDIF
    ENDIF
    IF m.Com = 'Date'
      APPEND BLANK
      GATHER MEMO FROM arry
      REPLACE Vpos WITH (m.ht+m.h0+m.hx+m.He+m.He+m.h1+m.h3+m.He+m.h4 ;
                         +iif(empty(m.pz),m.h5,m.He+m.h5)+1)*m.Koeff 
    ENDIF
    IF m.Com = 'Title' AND m.FirstPage = 1
      APPEND BLANK
      GATHER MEMO FROM arry
      IF m.kPage = 1
      ELSE
        IF !empty(evaluate(Expr))
          REPLACE Norepeat WITH .F.
        ENDIF
        REPLACE Expr WITH 'fspace("'+Expr+'")'
      ENDIF
    ENDIF
    hSum = 1
    FOR j = m.kPar1 TO m.kPar2
      IF inlist(m.Com, 'Title', 'PageHeader', 'Date', 'Group') 
        EXIT
      ENDIF             
      i = bColumns(m.j, 2)
      IF aColumns(m.i,7) = 0 OR aColumns(m.i,3) < 6
        LOOP
      ENDIF
      IF m.hSum + min(m.pp-2, aColumns(m.i,3)) + 1 > m.pp
        EXIT
      ENDIF  
      hSum = m.hSum + min(m.pp-2, aColumns(m.i,3)) + 1
      APPEND BLANK
      GATHER MEMO FROM arry
      DO CASE 
         CASE m.Com = 'Header'
           REPLACE Vpos WITH (m.ht+m.h0+m.hx+m.He)*m.Koeff 
           REPLACE Hpos WITH m.Hp
           REPLACE Expr WITH '"'+chrtran(aColumns(m.i,2),'"',"'")+'"' 
           REPLACE Width WITH aColumns(m.i,3)*m.Koeff
           REPLACE Height WITH m.He*m.Koeff 
           REPLACE FontFace WITH m.fn
           REPLACE FontSize WITH m.fs
           REPLACE FontStyle WITH iif(m.fb, 1, 0) + 2 * iif(m.fi, 1, 0)
           Hp = m.Hp + (aColumns(m.i,3)+1)*m.Koeff
         CASE m.Com = 'Left1line'
           REPLACE Vpos WITH (m.ht+m.h0+m.hx+m.He)*m.Koeff 
           Hp = m.Hp + (aColumns(m.i,3)+1)*m.Koeff
           REPLACE Hpos WITH m.Hp 
           REPLACE Height WITH m.He*m.Koeff 
         CASE m.Com = 'Left2line'
           REPLACE Vpos WITH (m.ht+m.h0+m.hx+m.He+m.He+m.h1+m.h3)*m.Koeff 
           Hp = m.Hp + (aColumns(m.i,3)+1)*m.Koeff
           REPLACE Hpos WITH m.Hp 
           REPLACE Height WITH m.He*m.Koeff 
         CASE m.Com = 'Hor1line'
           REPLACE Vpos WITH (m.ht+m.h0+m.hx+m.He)*m.Koeff 
           REPLACE Hpos WITH m.Hp
           REPLACE Width WITH (aColumns(m.i,3)+1)*m.Koeff
           Hp = m.Hp + (aColumns(m.i,3)+1)*m.Koeff
         CASE m.Com = 'Hor2line'
           REPLACE Vpos WITH (m.ht+m.h0+m.hx+m.He+m.He)*m.Koeff 
           REPLACE Hpos WITH m.Hp
           REPLACE Width WITH (aColumns(m.i,3)+1)*m.Koeff
           Hp = m.Hp + (aColumns(m.i,3)+1)*m.Koeff
         CASE m.Com = 'Hor3line'
           REPLACE Vpos WITH (m.ht+m.h0+m.hx+m.He+m.He+m.h1+m.He+m.h3)*m.Koeff 
           REPLACE Hpos WITH m.Hp
           REPLACE Width WITH (aColumns(m.i,3)+1)*m.Koeff
           Hp = m.Hp + (aColumns(m.i,3)+1)*m.Koeff
         CASE m.Com = 'Column'
           REPLACE Vpos WITH (m.ht+m.h0+m.hx+m.He+m.He+m.h1+m.h3)*m.Koeff 
           REPLACE Hpos WITH m.Hp
           REPLACE Expr WITH aColumns(m.i,1) 
           REPLACE Width WITH aColumns(m.i,3)*m.Koeff
           REPLACE Height WITH m.He*m.Koeff 
           pf = '@'+aColumns(m.i,4)+'  '
           px = at(' ', m.pf)
           IF m.px != 0
             pw = alltrim(substr(m.pf, m.px+1))
             pf = left(m.pf, m.px-1)
           ENDIF
           IF aColumns(m.i,5) = 'N'
             IF m.Variant = 1 OR inlist(m.Variant, 2, 3) AND len(m.pw) = 0
               px = at('.',aColumns(m.i,6))
               py = len(aColumns(m.i,6))
             ELSE
               px = at('.',m.pw)
               py = len(m.pw)
             ENDIF
             IF m.px = 0
               REPLACE Expr WITH 'round('+aColumns(m.i,1)+',0)' 
             ELSE
               REPLACE Expr WITH 'round('+aColumns(m.i,1)+','+ltrim(str(m.py-m.px))+')' 
             ENDIF
           ENDIF   
           REPLACE OffSet WITH iif(aColumns(m.i,5)='N',1,0)
           IF aColumns(m.i,5) = 'D'
             REPLACE SupExpr WITH '!empty('+aColumns(m.i,1)+')'
             REPLACE OffSet WITH 1
           ENDIF
           REPLACE FillChar WITH aColumns(m.i,5)
           REPLACE Picture WITH '"'+m.pf+'"'
           REPLACE FontFace WITH m.fn
           REPLACE FontSize WITH m.fs
           REPLACE FontStyle WITH iif(m.fb, 1, 0) + 2 * iif(m.fi, 1, 0)
           Hp = m.Hp + (aColumns(m.i,3)+1)*m.Koeff
      ENDCASE     
    ENDFOR
  ELSE
    APPEND BLANK
    GATHER MEMO FROM arry
    IF Objtype = 9 
      DO CASE
         CASE Objcode = 0
           REPLACE Height WITH m.ht * m.Koeff
         CASE Objcode = 1
           REPLACE Height WITH (m.he+m.hx+m.he) * m.Koeff
         CASE Objcode = 3
           REPLACE Height WITH 0
         CASE Objcode = 4
           REPLACE Height WITH m.he * m.Koeff
         CASE Objcode = 5
           IF empty(m.pz) OR m.kPage > 1
             REPLACE Height WITH 0
           ELSE
             REPLACE Height WITH m.he * m.Koeff
           ENDIF
         CASE Objcode = 7
           REPLACE Height WITH (m.he+m.hx) * m.Koeff
         CASE Objcode = 8
           REPLACE Height WITH 0
      ENDCASE
    ENDIF
  ENDIF
  SELECT Rpt1
ENDSCAN
*SELECT rpt2
*BROWSE
USE IN Rpt1
USE IN Rpt2
SELECT (wa)
RETURN
FUNCTION fspace
PARAMETER x
PRIVATE i, j, px, py
j = evaluate(m.x)
px = ''
FOR i = 1 TO len(m.j)
  py = substr(m.j,m.i,1)
  px = m.px + iif(inlist(m.py, chr(10),chr(13)),m.py, ' ')
ENDFOR
IF right(m.px,1) = ' '
  px = m.px + chr(13)+chr(10)
ENDIF
RETURN m.px