FUNCTION Calendar
PARAMETER Date, Title 
PUSH KEY CLEAR
IF type('f_calendar') != 'L'
  PUBLIC f_calendar
  f_calendar = .f.
ENDIF
IF type('m.Date') != 'D'
  Date = date()
ENDIF  
IF type('m.Title') != 'C'
  Title = ''
ENDIF
IF f_calendar
  POP KEY
  RETURN m.Date
ENDIF 
f_calendar = .t.
LOCAL oFSet, oForm, i, jr, jc, aMonth
DIMENSION aMonth(12)
aMonth( 1) = ''
aMonth( 2) = ''
aMonth( 3) = ''
aMonth( 4) = ''
aMonth( 5) = ''
aMonth( 6) = ''
aMonth( 7) = ''
aMonth( 8) = ''
aMonth( 9) = ''
aMonth(10) = ''
aMonth(11) = ''
aMonth(12) = ''
oFSet = CreateObject('FormSet')
oFset.AddObject('oForm', 'frmCalendar')
oFset.oForm.Caption = m.Title
oFset.oForm.opgMonth.ButtonCount = 12
FOR i = 1 TO 12
    oFset.oForm.opgMonth.Buttons(m.i).Style = 1
    oFset.oForm.opgMonth.Buttons(m.i).Caption = aMonth(m.i)
    oFset.oForm.opgMonth.Buttons(m.i).Top = 7 + (m.i - 1) * 19
    oFset.oForm.opgMonth.Buttons(m.i).Left = 15
    oFset.oForm.opgMonth.Buttons(m.i).Height = 17
    oFset.oForm.opgMonth.Buttons(m.i).Width = 80
    oFset.oForm.opgMonth.Buttons(m.i).FontBold = .T.
ENDFOR
oFset.oForm.opgDay.ButtonCount = 42
FOR jc = 1 TO 6
  FOR jr = 1 TO 7
    i = (m.jc - 1) * 7 + m.jr
    oFset.oForm.opgDay.Buttons(m.i).Style = 1
    oFset.oForm.opgDay.Buttons(m.i).Caption = ltrim(str(m.i))
    oFset.oForm.opgDay.Buttons(m.i).Top = 12  + (m.jr - 1) * 31
    oFset.oForm.opgDay.Buttons(m.i).Left = 45 + (m.jc - 1) * 31
    oFset.oForm.opgDay.Buttons(m.i).Height = 25
    oFset.oForm.opgDay.Buttons(m.i).Width = 25
    oFset.oForm.opgDay.Buttons(m.i).FontBold = .T.
  ENDFOR
ENDFOR
oFset.oForm.Date = m.Date
oFset.oForm.Calend()
oFset.WindowType = 1
oFset.AutoRelease = .T.
*oFset.WindowType = 3
oFset.oForm.Show()
*READ EVENTS
*oFset.Release
f_calendar = .f.
POP KEY
RETURN m.Date

DEFINE CLASS frmCalendar AS Form
  ScaleMode = 3
  Caption = ''
  Height = 310
  Width = 390
  AutoCenter = .T.
  MaxButton = .F.
  MinButton = .F.
*  Closable = .T.
  Closable = .F.
  ControlBox = .F.
  Movable = .F.
  ShowTips = .T.
  Date = {}
  WindowType = 1
  ShowWindow = 1
  ADD OBJECT imgCalendar AS Image WITH ;
    Top = 9, ;
    Left = 16, ;
    Height = 32, ;
    Width = 32, ;
    Stretch = 2, ;
    Picture = 'Calendar.bmp'
  ADD OBJECT spnYear AS Spinner WITH ;
    Top = 11, ;
    Left = 52, ;
    Height = 26, ;
    Width = 72, ;
    FontSize = 12, ;
    FontBold = .T., ;
    FontName = 'Arial', ;
    SpinnerHighValue = 2100.00, ;
    SpinnerLowValue = 1900.00
    InputMask = '9999' 
*    KeyboardHighValue = 2100
*    KeyboardLowValue = 1900
  ADD OBJECT opgMonth AS OptionGroup WITH ;
    Top = 48, ;
    Left = 16, ;
    Height = 240, ;
    Width = 108

  ADD OBJECT opgDay AS OptionGroup WITH ;
    Top = 48, ;
    Left = 140, ;
    Height = 240, ;
    Width = 233

  ADD OBJECT cmdToday AS CommandButton WITH ;
    Caption = '', ;
    FontSize = 11, ;
    FontBold = .T., ;
    Top = 13, ;
    Left = 140, ;
    Height = 25, ;
    Width = 70
  ADD OBJECT cmdOK AS CommandButton WITH ;
    Caption = '', ;
    Picture = 'OK.bmp', ;
    FontSize = 11, ;
    FontBold = .T., ;
    Top = 13, ;
    Left = 237, ;
    Height = 25, ;
    Width = 61, ;
    ToolTipText = ''
  
  ADD OBJECT cmdCancel AS CommandButton WITH ;
    Cancel = .T., ;
    Caption = '', ;
    Picture = 'Cancel.bmp', ;
    FontSize = 11, ;
    FontBold = .T., ;
    Top = 13, ;
    Left = 313, ;
    Height = 25, ;
    Width = 61, ;
    ToolTipText = ''
    
  ADD OBJECT lbl1 AS Label WITH ;
    Top = 62 + 0 * 31, ;
    Left = 149, ;
    Height = 25, ;
    Width = 25, ;
    FontSize = 11, ;
    FontBold = .T., ;
    Caption = ''
  ADD OBJECT lbl2 AS Label WITH ;
    Top = 62 + 1 * 31, ;
    Left = 149, ;
    Height = 25, ;
    Width = 25, ;
    FontSize = 11, ;
    FontBold = .T., ;
    Caption = ''
  ADD OBJECT lbl3 AS Label WITH ;
    Top = 62 + 2 * 31, ;
    Left = 149, ;
    Height = 25, ;
    Width = 25, ;
    FontSize = 11, ;
    FontBold = .T., ;
    Caption = ''
  ADD OBJECT lbl4 AS Label WITH ;
    Top = 62 + 3 * 31, ;
    Left = 149, ;
    Height = 25, ;
    Width = 25, ;
    FontSize = 11, ;
    FontBold = .T., ;
    Caption = ''
  ADD OBJECT lbl5 AS Label WITH ;
    Top = 62 + 4 * 31, ;
    Left = 149, ;
    Height = 25, ;
    Width = 25, ;
    FontSize = 11, ;
    FontBold = .T., ;
    Caption = ''
  ADD OBJECT lbl6 AS Label WITH ;
    Top = 62 + 5 * 31, ;
    Left = 149, ;
    Height = 25, ;
    Width = 25, ;
    FontSize = 11, ;
    FontBold = .T., ;
    Caption = '', ;
    ForeColor = rgb(255,0, 0) 
  ADD OBJECT lbl7 AS Label WITH ;
    Top = 62 + 6 * 31, ;
    Left = 149, ;
    Height = 25, ;
    Width = 25, ;
    FontSize = 11, ;
    FontBold = .T., ;
    Caption = '', ;
    ForeColor = rgb(255,0, 0) 

  PROCEDURE Calend
    LOCAL i, jc, jr, cDate, nDate, kDays, Dow
    cDate = ThisForm.Date
    ThisForm.spnYear.Value = year(m.cDate)
    FOR i = 1 TO 12
      ThisForm.opgMonth.Buttons(m.i).Value = iif(m.i = month(cDate),1,0)
    ENDFOR
    nDate = m.cDate - day(m.cDate) + 1
    kDays = day(gomonth(m.nDate,1) - 1)
    Dow = dow(m.nDate)
    Dow = iif(m.Dow = 1, 7, m.Dow - 1) 
    FOR jc = 1 TO 6
      FOR jr = 1 TO 7
        i = (m.jc - 1) * 7 + m.jr
        IF between(m.i, Dow, Dow+kDays-1)
          ThisForm.opgDay.Buttons(m.i).Caption = ltrim(str(m.i-m.Dow+1))
          ThisForm.opgDay.Buttons(m.i).Enabled = .T.
        ELSE
          ThisForm.opgDay.Buttons(m.i).Caption = ''
          ThisForm.opgDay.Buttons(m.i).Enabled = .F.
        ENDIF
        IF m.i - Dow + 1 = Day(cDate)
          ThisForm.opgDay.Buttons(m.i).Value = 1
        ELSE
          ThisForm.opgDay.Buttons(m.i).Value = 0
        ENDIF
      ENDFOR
    ENDFOR
  ENDPROC
 
  PROCEDURE OpgMonth.Click
    LOCAL i
    FOR i = 1 TO 12
      IF This.Buttons(m.i).Value != 0
         ThisForm.Date = gomonth(ThisForm.Date, m.i - month(ThisForm.Date)) 
         ThisForm.Calend()
        EXIT
      ENDIF 
    ENDFOR
  ENDPROC  

*  PROCEDURE spnYear.InterActiveChange
  PROCEDURE spnYear.Valid
        This.Value = max(This.Value, int(This.SpinnerLowValue))
        This.Value = min(This.Value, int(This.SpinnerHighValue))
        ThisForm.Date = gomonth(ThisForm.Date, 12 * (This.Value - year(ThisForm.Date))) 
        ThisForm.Calend()
*        IF between(This.Value, This.KeyboardLowValue, This.KeyboardHighValue)
*          ThisForm.Date = gomonth(ThisForm.Date, 12 * (This.Value - year(ThisForm.Date))) 
*          ThisForm.Calend()
*        ELSE
*          RETURN .F.
*        ENDIF  
  ENDPROC  
  PROCEDURE spnYear.DownClick
        This.Value = max(This.Value, int(This.SpinnerLowValue))
        This.Value = min(This.Value, int(This.SpinnerHighValue))
        ThisForm.Date = gomonth(ThisForm.Date, 12 * (This.Value - year(ThisForm.Date))) 
        ThisForm.Calend()
  ENDPROC  
  PROCEDURE spnYear.UpClick
        This.Value = max(This.Value, int(This.SpinnerLowValue))
        This.Value = min(This.Value, int(This.SpinnerHighValue))
        ThisForm.Date = gomonth(ThisForm.Date, 12 * (This.Value - year(ThisForm.Date))) 
        ThisForm.Calend()
  ENDPROC  
*  PROCEDURE spnYear.ErrorMessage
*    RETURN ' '
*  ENDPROC

  PROCEDURE OpgDay.Click
    LOCAL i
    FOR i = 1 TO 42
      IF This.Buttons(m.i).Value != 0
        ThisForm.Date = ThisForm.Date + (val(This.Buttons(m.i).Caption) - day(ThisForm.Date)) 
        EXIT
      ENDIF 
    ENDFOR
  ENDPROC  

  PROCEDURE cmdToday.Click
    ThisForm.Date = date() 
    ThisForm.Calend()
  ENDPROC  
  PROCEDURE cmdOK.Click
    Date = ThisForm.Date
    ThisForm.Release
*    CLEAR EVENTS
  ENDPROC  
  PROCEDURE cmdCancel.Click
     ThisForm.Release
*    CLEAR EVENTS
  ENDPROC  
ENDDEFINE  
  