FUNCTION fGraph2
PARAMETERS Nus, A, nY1, nY2, Title, xTitle, y1Title, y2Title
PRIVATE w, n, n1, n2, T, Tx, Ty1, Ty2, k, m, r, s, nf, nf, i, oXl, j, h, e, Fy2
EXTERNAL ARRAY A
w = SELECT()
*      CANCEL ( ) ;
*  ( *)     EXCEL :
*  IF TYPE('oXl') = 'O'
*    oXl.Application.DisplayAlerts = .F.
*    oXl.Application.Quit
*    oXl = 0
*  ENDIF 

* Nus -  
n1 = m.nY1  &&    .
n2 = m.nY2  &&    .
n = m.n1 + m.n2 
*  :
*   1 - x
*   2 - y1
*  . . .
*   n+1 - yn
*  ,    A,   , 
*    . ,     ,  EXCEL     
* A -   
T = m.Title  &&   
IF TYPE('m.T') != 'C'
  T = ''
ENDIF   
Tx = m.xTitle  &&   X 
IF TYPE('m.Tx') != 'C'
  Tx = ''
ENDIF   
Ty1 = m.y1Title  &&   Y ()
IF TYPE('m.Ty1') != 'C'
  Ty1 = ''
ENDIF   
Ty2 = m.y2Title  &&   Y ()
IF TYPE('m.Ty2') != 'C'
  Ty2 = ''
ENDIF   

k = FCOUNT()  &&    
m = ALEN(A)  &&   
n = MIN(m.n + 1, m.k, m.m) - 1
IF m.n < 1
  RETURN
ENDIF 
r = 0  &&    
CALCULATE SUM(1) TO r
s = 'SET FIELDS TO'
FOR i = 1 TO MIN(m.k, m.m)
  s = m.s + IIF(m.i=1, ' ', ', ') + ALLTRIM(FIELD(m.i))
ENDFOR
&s  &&    ,   EXCEL

*   
FOR i = 1 TO 99
  j = TRANSFORM(m.i, '@L ##')
  nf = FULLPATH('')+'Grf'+ALLTRIM(STR(m.Nus))+'_'+m.j+'.dbf'
  nx = FULLPATH('')+'Grf'+ALLTRIM(STR(m.Nus))+'_'+m.j+'.xls'
  h = FCREATE(m.nf)
  IF m.h < 0
    LOOP
  ENDIF
  = FCLOSE(m.h)
  DELETE FILE (nf)
  h = FCREATE(m.nx)
  IF m.h < 0
    LOOP
  ENDIF
  = FCLOSE(m.h)
  DELETE FILE (nx)
  EXIT
ENDFOR

COPY TO (nf) TYPE FOX2X AS 866
SET FIELDS TO

*   EXCEL
j = "createobject('Excel.Application')"
IF TYPE('evaluate(m.j)') != 'O'
  WAIT WINDOW '  EXCEL !'
  RETURN
ENDIF

***
e = ON('Error')
IF EMPTY(m.e)
  ON ERROR DO fExErr
ENDIF
*  EXCEL
oXl = createobject('Excel.Application')
*oXl.Application.Visible = .T.

*  
oXl.Workbooks.Open(m.nf) 
oXl.Sheets(1).Select
oXl.Sheets(1).Name = ""
*     
s = ASC('A') - 1
FOR i = 1 TO MIN(m.m, m.k)
  s = m.s + 1
  oXl.Range(CHR(m.s)+'1').Select
  oXl.ActiveCell.FormulaR1C1 = A(m.i)
ENDFOR
IF TYPE(fields(1)) = 'D'
  oXl.Columns("A:A").NumberFormat = "dd.mm.yy"
ENDIF

*  
oXl.Charts.Add
oXl.ActiveChart.Location(1, "") &&    
oXl.ActiveChart.ChartType = 65  &&   
oXl.ActiveChart.SetSourceData(oXl.Sheets("").Range('B2:'+CHR(ASC('A')+m.n)+LTRIM(STR(m.r+1))), 2)  &&  
*    
Fy2 = .F.
FOR i = 1 TO m.n 
  oXl.ActiveChart.SeriesCollection(m.i).XValues = '=!R2C1:R'+LTRIM(STR(m.r+1))+'C1'
  oXl.ActiveChart.SeriesCollection(m.i).Name = A(m.i+1)
  IF m.i > m.n1
    oXl.ActiveChart.SeriesCollection(m.i).AxisGroup = 2
    Fy2 = .T.
  ENDIF
ENDFOR
oXl.ActiveChart.PlotArea.Interior.ColorIndex = 2  &&  
IF !EMPTY(m.T)
  oXl.ActiveChart.HasTitle = .T.
  oXl.ActiveChart.ChartTitle.Characters.Text = m.T  && ,  
ELSE
  oXl.ActiveChart.HasTitle = .F.
ENDIF
IF !EMPTY(m.Tx)
  oXl.ActiveChart.Axes(1,1).HasTitle = .T.
  oXl.ActiveChart.Axes(1,1).AxisTitle.Characters.Text = m.Tx  &&   X,  
ELSE
  oXl.ActiveChart.Axes(1, 1).HasTitle = .F.
ENDIF
IF !EMPTY(m.Ty1)
  oXl.ActiveChart.Axes(2,1).HasTitle = .T.
  oXl.ActiveChart.Axes(2,1).AxisTitle.Characters.Text = m.Ty1  &&   Y (),  
ELSE
  oXl.ActiveChart.Axes(2,1).HasTitle = .F.
ENDIF
IF m.Fy2
  IF !EMPTY(m.Ty2)
    oXl.ActiveChart.Axes(2,2).HasTitle = .T.
    oXl.ActiveChart.Axes(2,2).AxisTitle.Characters.Text = m.Ty2  &&   Y (),  
  ELSE
    oXl.ActiveChart.Axes(2,2).HasTitle = .F.
  ENDIF
ENDIF
IF TYPE(fields(1)) = 'D'
  oXl.ActiveChart.Axes(1).CategoryType = 3  &&  
  oXl.ActiveChart.Axes(1).TickLabels.NumberFormat = "dd.mm.yy"  &&  
ENDIF
oXl.ActiveChart.Axes(1).TickLabels.Orientation = -4171  &&    x 
oXl.ActiveChart.Axes(1).TickLabels.Font.Size = 9
oXl.ActiveChart.Axes(1).AxisBetweenCategories = .F. 
oXl.ActiveChart.Legend.Position = -4160  &&     
oXl.ActiveChart.PageSetup.Orientation = 2 &&  - 
oXl.ActiveChart.Deselect
DELETE FILE (nx)
oXl.ActiveWorkbook.SaveAs(m.nx, -4143)  &&    EXCEL
*WAIT WINDOW oXl.ActiveChart.Axes(1).TickLabels.NumberFormat
oXl.Application.Visible = .T.
***
oXl = 0
IF EMPTY(m.e)
  ON ERROR
ENDIF
RETURN   

FUNCTION fA
PARAMETERS n, z
PRIVATE n1, n2, s
n1 = INT((m.n - 1) / 26)
n2 = m.n - 1 - m.n1 * 26
s = IIF(m.n1 = 0, '', CHR(ASC('A')+m.n1-1))+CHR(ASC('A')+m.n2)  
IF TYPE('m.z') = 'N'
  s = m.s + LTRIM(STR(m.z))
ENDIF
*WAIT m.s
RETURN m.s

FUNCTION fExErr
PRIVATE ErrNum, msg
ErrNum = error()
msg = ' : '+alltrim(message())
IF MESSAGEBOX(m.msg+chr(13)+' '+'?',4+16+256,'!')=6
  IF TYPE('oXl') = 'O'
    oXl.Application.DisplayAlerts = .F.
    oXl.Application.Quit
    oXl = 0
  ENDIF 
  CANCEL
ENDIF
RETURN
