FUNCTION grcPoisk
PARAMETER grcName
PRIVATE p_Text, p_Flag1, p_Flag2, p_Flag3 
p_Text = grcName.pText
p_Flag1 = grcName.pF1
p_Flag2 = grcName.pF2
p_Flag3 = grcName.pF3
PUSH KEY CLEAR
IF type('p_Text') = 'L'
  p_Text = ''
ENDIF
LOCAL kw, kh
kw = sysmetric(1)/800 
kh = sysmetric(2)/600
LOCAL oForm, oFset
PRIVATE p_Poisk
p_Poisk = .f.
oFSet = CreateObject('FormSet')
oFset.AddObject('oForm', 'frmPoisk')
oFset.WindowType = 3
ON KEY LABEL Enter KEYBOARD '{Ctrl-Enter}'
oFset.oForm.Show()
oFset.Release
ON KEY LABEL Enter
IF m.p_Poisk
  grcName.pText = m.p_Text
  grcName.pF1 = m.p_Flag1  
  grcName.pF2 = m.p_Flag2  
  grcName.pF3 = m.p_Flag3  
ENDIF
POP KEY
RETURN m.p_Poisk

DEFINE CLASS frmPoisk AS Form
  ScaleMode = 3
  Caption = ''
  Height = 180*m.kh
  Width = 340*m.kw
  MaxHeight = 180*m.kh
  MaxWidth = 340*m.kw
  MinHeight = 180*m.kh
  MinWidth = 340*m.kw
  Icon = 'find.ico' 
  AutoCenter = .T.
  MaxButton = .F.
  MinButton = .F.
  Closable = .T.
  ControlBox = .T.
  Movable = .F.
  ShowWindow = 2
  ShowTips = .T.

  ADD OBJECT edtText AS EditBox WITH ;
    ControlSource = 'p_Text', ;
    Format = 'K', ; 
    ScrollBars = 0, ;
    Top = 24*m.kh, ;
    Left = 24*m.kw, ;
    Height = 25*m.kh, ;
    Width = 290*m.kw, ;
    FontName = 'Courier New', ;
    FontSize = 12*m.kh, ;
    FontBold = .T.
  ADD OBJECT chkCheck1 AS CheckBox WITH ;
    Caption = '   ', ; 
    ControlSource = 'p_Flag1', ;
    Top = 72*m.kh, ;
    Left = 24*m.kw, ;
    Height = 25*m.kh, ;
    Width = 173*m.kw, ;
    FontName = 'Times New Roman', ;
    FontSize = 11*m.kh
  ADD OBJECT chkCheck2 AS CheckBox WITH ;
    Caption = '  ', ; 
    ControlSource = 'p_Flag2', ;
    Top = 105*m.kh, ;
    Left = 24*m.kw, ;
    Height = 25*m.kh, ;
    Width = 173*m.kw, ;
    FontName = 'Times New Roman', ;
    FontSize = 11*m.kh
  ADD OBJECT chkCheck3 AS CheckBox WITH ;
    Caption = '   ', ; 
    ControlSource = 'p_Flag3', ;
    Top = 137*m.kh, ;
    Left = 24*m.kw, ;
    Height = 25*m.kh, ;
    Width = 173*m.kw, ;
    FontName = 'Times New Roman', ;
    FontSize = 11*m.kh
  ADD OBJECT cmdOK AS CommandButton WITH ;
    Default = .T., ;
    Caption = '', ;
    FontName = 'Times New Roman', ;
    FontSize = 11*m.kh, ;
    FontBold = .T., ;
    Top = 72*m.kh, ;
    Left = 230*m.kw, ;
    Height = 37*m.kh, ;
    Width = 84*m.kw
  
  ADD OBJECT cmdCancel AS CommandButton WITH ;
    Cancel = .T., ;
    Caption = '', ;
    FontName = 'Times New Roman', ;
    FontSize = 11*m.kh, ;
    FontBold = .T., ;
    Top = 125*m.kh, ;
    Left = 230*m.kw, ;
    Height = 37*m.kh, ;
    Width = 84*m.kw

  PROCEDURE cmdOK.Click
    p_Poisk = .T.
    ThisForm.Release
*    CLEAR EVENTS
  ENDPROC  
  PROCEDURE cmdCancel.Click
    p_Poisk = .F.
    ThisForm.Release
*    CLEAR EVENTS
  ENDPROC  
ENDDEFINE  
  