FUNCTION vibArray
PARAMETERS qqList, zTitle, nList, nSort
PUSH KEY CLEAR
EXTERNAL ARRAY qqList
PRIVATE oFSet, oForm 
PRIVATE RetCode, j, qList
RetCode = 0  
IF type('m.nList') = 'N' 
  IF !between(m.nList, 1, alen(qqList,1))
    nList = 1
  ENDIF
ELSE
  nList = 1
ENDIF
IF type('m.nSort') = 'N' 
  IF !between(m.nSort, 1, 2)
    nSort = 1
  ENDIF
ELSE
  nSort = 1
ENDIF
DIMENSION qList(alen(qqList,1),3)
FOR j = 1 TO alen(qqList,1)
  qList(m.j,1) = qqList(m.j,1)
  qList(m.j,2) = qqList(m.j,2)
  qList(m.j,3) = m.j
ENDFOR
= asort(qList, m.nSort)
FOR j = 1 TO alen(qList,1)
  IF qList(m.j, 3) = m.nList
    nList = m.j
    EXIT
  ENDIF   
ENDFOR
oFSet = CreateObject('FormSet')
oFset.WindowType = 3
oFset.AutoRelease = .T.
oFset.AddObject('oForm', 'frmVibor')
oFset.oForm.Caption = m.zTitle

oFset.oForm.lbxList.ControlSource = 'nList'
oFset.oForm.lbxList.RowSource = 'qList'

oFset.oForm.opgHeader.ButtonCount = 2

oFset.oForm.opgHeader.Buttons(1).Style = 1
oFset.oForm.opgHeader.Buttons(1).Caption = ''
oFset.oForm.opgHeader.Buttons(1).Top = 0
oFset.oForm.opgHeader.Buttons(1).Left = 0
oFset.oForm.opgHeader.Buttons(1).Height = 20
oFset.oForm.opgHeader.Buttons(1).Width = 355
oFset.oForm.opgHeader.Buttons(1).FontBold = .T.
oFset.oForm.opgHeader.Buttons(1).FontName = 'Times New Roman'
oFset.oForm.opgHeader.Buttons(1).FontSize = 12
oFset.oForm.opgHeader.Buttons(1).ToolTipText = '  '
oFset.oForm.opgHeader.Buttons(1).Value = iif(m.nSort=1, 1, 0)

oFset.oForm.opgHeader.Buttons(2).Style = 1
oFset.oForm.opgHeader.Buttons(2).Caption = ''
oFset.oForm.opgHeader.Buttons(2).Top = 0
oFset.oForm.opgHeader.Buttons(2).Left = 355
oFset.oForm.opgHeader.Buttons(2).Height = 20
oFset.oForm.opgHeader.Buttons(2).Width = 85
oFset.oForm.opgHeader.Buttons(2).FontBold = .T.
oFset.oForm.opgHeader.Buttons(2).FontName = 'Times New Roman'
oFset.oForm.opgHeader.Buttons(2).FontSize = 12
oFset.oForm.opgHeader.Buttons(2).ToolTipText = '  '
oFset.oForm.opgHeader.Buttons(2).Value = iif(m.nSort=2, 1, 0)

oFset.oForm.Show()
POP KEY
RETURN iif(m.RetCode = 0, 0 , qList(m.RetCode, 3))

DEFINE CLASS frmVibor AS Form
  ScaleMode = 3
  Height = 300
  Width = 500
  AutoCenter = .T.
  MaxButton = .F.
  MinButton = .F.
*  Closable = .T.
  Closable = .F.
  ControlBox = .F.
  Movable = .F.
  WindowType = 1
  ShowTips = .T.
  ShowWindow = 1
  
  ADD OBJECT lbxList AS ListBox WITH ;
    FontName = 'Times New Roman', ;
    FontSize = 12, ;
    FontBold = .T., ;
    Top = 40, ;
    Left = 20, ;
    Height = 200, ;
    Width = 460, ;
    DisplayValue = 1, ;
    ColumnCount = 2, ;
    BoundColumn = 2, ;
    ColumnWidths = '350, 90', ;
    Sorted = .F., ;
    RowSourceType = 5

  PROCEDURE lbxList.DblClick
    RetCode  = ThisForm.lbxList.Value
    ThisForm.Release
  ENDPROC  
  PROCEDURE lbxList.GotFocus
     This.SelectedItemBackColor = RGB(96,232,255)
  ENDPROC  
  PROCEDURE lbxList.LostFocus
     This.SelectedItemBackColor = RGB(192,192,192)
  ENDPROC  
  
  ADD OBJECT opgHeader AS OptionGroup WITH ;
    BorderStyle = 0, ;
    Top = 20, ;
    Left = 20, ;
    Height = 20, ;
    Width = 440

  PROCEDURE OpgHeader.Click
    LOCAL i, x2
    EXTERNAL ARRAY qList
    x2 = qList(ThisForm.lbxList.Value,3)
    IF This.Buttons(1).Value = 1
      nSort = 1
      = asort(qList,1) 
    ELSE
      nSort = 2
      = asort(qList,2) 
    ENDIF 
    ThisForm.Refresh
    ThisForm.lbxList.SetFocus
    FOR i=1 TO alen(qList,1)
      IF qList(m.i,3) = m.x2
        ThisForm.lbxList.Value = m.i
        ThisForm.lbxList.ListIndex = m.i
        EXIT
      ENDIF
    ENDFOR
  ENDPROC  

  ADD OBJECT cmdOK AS CommandButton WITH ;
    Caption = '', ;
    FontName = 'Times New Roman', ;
    FontSize = 12, ;
    FontBold = .T., ;
    Top = 250, ;
    Left = 80, ;
    Height = 40, ;
    Width = 120, ;
    ToolTipText = ''
*    Picture = OK.bmp'
  
  ADD OBJECT cmdCancel AS CommandButton WITH ;
    Cancel = .T., ;
    Caption = '³', ;
    FontName = 'Times New Roman', ;
    FontSize = 12, ;
    FontBold = .T., ;
    Top = 250, ;
    Left = 280, ;
    Height = 40, ;
    Width = 120, ;
    ToolTipText = '³'
*    Picture = 'Cancel.bmp'
    
  PROCEDURE cmdOK.Click
    RetCode  = ThisForm.lbxList.Value
    ThisForm.Release
  ENDPROC  
  PROCEDURE cmdCancel.Click
     RetCode = 0
     ThisForm.Release
  ENDPROC  
ENDDEFINE  
  