FUNCTION editText
PARAMETER cText, nText
IF type('cText') != 'C'
  RETURN
ENDIF
PUSH KEY CLEAR
IF type('nText') != 'C'
  nText = ''
ENDIF
LOCAL kw, kh
*kw = sysmetric(1)/800 
*kh = sysmetric(2)/600
kw = 1 
kh = 1
PRIVATE oForm, oFset, p_Text
p_Text = m.cText
oFSet = CreateObject('FormSet')
oFset.AddObject('oForm', 'frmText')
oFset.WindowType = 3
oFset.oForm.Caption = m.nText
oFset.oForm.Show()
oFset.Release
POP KEY
RETURN m.cText

DEFINE CLASS frmText AS Form
  ScaleMode = 3
  Caption = m.nText
  Top = 120
  Left = 25
  Height = 280*m.kh
  Width = 740*m.kw
  MaxHeight = 280*m.kh
  MaxWidth = 740*m.kw
  MinHeight = 280*m.kh
  MinWidth = 740*m.kw
  AutoCenter = .T.
  ShowWindow = 2
  MaxButton = .F.
  MinButton = .F.
  Closable = .T.
  ControlBox = .T.
  Movable = .F.
  ShowTips = .T.

  ADD OBJECT edtText AS EditBox WITH ;
    ControlSource = 'p_Text', ;
    ScrollBars = 2, ;
    Top = 10*m.kh, ;
    Left = 20*m.kw, ;
    Height = 210*m.kh, ;
    Width = 700*m.kw, ;
    FontName = 'Courier New', ;
    FontSize = 12*m.kh, ;
    FontBold = .T.
  ADD OBJECT cmdOK AS CommandButton WITH ;
    Default = .T., ;
    Caption = '', ;
    FontName = 'Times New Roman', ;
    FontSize = 11*m.kh, ;
    FontBold = .T., ;
    Top = 235*m.kh, ;
    Left = 200*m.kw, ;
    Height = 30*m.kh, ;
    Width = 80*m.kw
  
  ADD OBJECT cmdCancel AS CommandButton WITH ;
    Cancel = .T., ;
    Caption = '', ;
    FontName = 'Times New Roman', ;
    FontSize = 11*m.kh, ;
    FontBold = .T., ;
    Top = 235*m.kh, ;
    Left = 460*m.kw, ;
    Height = 30*m.kh, ;
    Width = 80*m.kw

  PROCEDURE cmdOK.Click
    cText = m.p_Text
    ThisForm.Release
*    CLEAR EVENTS
  ENDPROC  
  PROCEDURE cmdCancel.Click
    ThisForm.Release
*    CLEAR EVENTS
  ENDPROC  
ENDDEFINE  
  